
Global NewList debugstring.s()
Global debugmutex = CreateMutex()

Procedure DebugCallback(string.s)
  LockMutex(debugmutex)
    AddElement(debugstring())
    debugstring() = string
  UnlockMutex(debugmutex)
EndProcedure

PBSSetDebugCallback(#PB_Default, @DebugCallback())


file.s = ProgramParameter()
If (ProgramParameter() = "START")
  isstartcode = #True
EndIf

If (file = "")
  MessageRequester("PBScript-Compiler", "Dieses Programm kann nur mit einer Script-Datei als Parameter aufgerufen werden."+Chr(10)+"Verwenden sie diesen Programm am besten als Tool in der PureBasic-IDE.")
  End
EndIf

*bytecode = PBSCompileScriptFile(file)
If (*bytecode = #Null)
  MessageRequester("PBScript-Compiler", PBSGetErrorText())
  End
EndIf
If (PBSOpenByteMemory(0, *bytecode) = #False)
  MessageRequester("PBScript-Compiler", PBSGetErrorText())
  End
EndIf


Structure collectwindow
  winid.i
  listid.i
  name.s
  range.s
  collect.b
  size.i
EndStructure

Structure dimrange
  min.i
  max.i
  pos.i
EndStructure


Global IsScriptRun
Global ThreadID
Global Dim ProcParam.PBSValue(0)
Global CountProcParam

Global NewList collectwindow.collectwindow()
Global globalstring.s

value.PBSValue


Procedure.s GetTypeText(type)
  Select type
  Case #PBSType_Ascii:     ProcedureReturn "Ascii"
  Case #PBSType_Byte:      ProcedureReturn "Byte"
  Case #PBSType_Character: ProcedureReturn "Character"
  Case #PBSType_Double:    ProcedureReturn "Double"
  Case #PBSType_Float:     ProcedureReturn "Float"
  Case #PBSType_Integer:   ProcedureReturn "Integer"
  Case #PBSType_Long:      ProcedureReturn "Long"
  Case #PBSType_Quad:      ProcedureReturn "Quad"
  Case #PBSType_String:    ProcedureReturn "String"
  Case #PBSType_Unicode:   ProcedureReturn "Unicode"
  Case #PBSType_Word:      ProcedureReturn "Word"
  Case #PBSType_Structure: ProcedureReturn "Structure"
  EndSelect
EndProcedure


Procedure.s GetValueText(*value.PBSValue, isinput=#False)
  Select *value\type
  Case #PBSType_Ascii, #PBSType_Byte, #PBSType_Integer, #PBSType_Long, #PBSType_Quad, #PBSType_Unicode, #PBSType_Word
    ProcedureReturn Str(*value\quad)
  Case #PBSType_Character
    ProcedureReturn Str(*value\character)
  Case #PBSType_Float
    ProcedureReturn StrF(*value\float)
  Case #PBSType_Double
    ProcedureReturn StrD(*value\double)
  Case #PBSType_String
    If (isinput = #True)
      If (*value\string = #Null)
        ProcedureReturn ""
      Else
        ProcedureReturn PeekS(*value\string)
      EndIf
    Else
      If (*value\string = #Null)
        ProcedureReturn Chr(34)+Chr(34)
      Else
        ProcedureReturn Chr(34)+PeekS(*value\string)+Chr(34)
      EndIf
    EndIf
  EndSelect
EndProcedure


Procedure InputValueText(*value.PBSValue)
  input.s = InputRequester("PBSScript-Compiler", "Setzte Wert auf:", GetValueText(*value,#True))
  If (input = "") And (*value\type <> #PBSType_String)
    ProcedureReturn #False
  EndIf
  Select *value\type
  Case #PBSType_Ascii, #PBSType_Byte, #PBSType_Integer, #PBSType_Long, #PBSType_Quad, #PBSType_Unicode, #PBSType_Word
    *value\quad = Val(input)
  Case #PBSType_Character
    *value\character = Val(input)
  Case #PBSType_Float
    *value\float = ValF(input)
  Case #PBSType_Double
    *value\double = ValD(input)
  Case #PBSType_String
    globalstring = input
    *value\string = @globalstring
  EndSelect
  ProcedureReturn #True
EndProcedure


Procedure AddStrucItem(gadget, name.s, struc.s)
  Protected value.PBSValue
  count = PBSGetStructureCountItems(0, struc)
  For i = 0 To count-1
    type = PBSGetStructureItemType(0, struc, i)
    If (type <> #PBSType_StructureUnion) And (type <> #PBSType_EndStructureUnion)
      newname.s = name+"\"+PBSGetStructureItemName(0, struc, i)
      cntarray = PBSGetStructureItemArray(0, struc, i)
      value\type = type
      If (cntarray = -1)
        AddGadgetItem(gadget, -1, "("+GetTypeText(type)+")"+Chr(10)+newname+Chr(10)+GetValueText(value))
        If (type = #PBSType_Structure)
          AddStrucItem(gadget, newname, PBSGetStructureItemStruc(0, struc, i))
        EndIf
      Else
        For k = 0 To cntarray-1
          AddGadgetItem(gadget, -1, "("+GetTypeText(type)+")"+Chr(10)+newname+"["+Str(k)+"]"+Chr(10)+GetValueText(value))
          If (type = #PBSType_Structure)
            AddStrucItem(gadget, newname+"["+Str(k)+"]", PBSGetStructureItemStruc(0, struc, i))
          EndIf
        Next
      EndIf
    EndIf
  Next
EndProcedure


Procedure StartCode(proc)
  Protected value.PBSValue
  If (proc = 0)
    If (PBSStartByteCode(0) = 0)
      error = #True
    EndIf
  Else
    name.s = StringField(GetGadgetItemText(0,proc),1,"(")
    If (PBSCallProcedure(0, name, value, CountProcParam, ProcParam()) = 0)
      error = #True
    EndIf
  EndIf
  IsScriptRun = -1
  If (error = #True)
    StatusBarText(0, 0, "Programm mit einem Fehler beendet: "+PBSGetErrorText(), #PB_StatusBar_Center)
    MessageRequester("PBSScript-Compiler", "Fehler zur Laufzeit:"+Chr(10)+PBSGetErrorText())
  Else
    StatusBarText(0, 0, "Programm beendet", #PB_StatusBar_Center)
  EndIf
  DisableGadget(0, 0)
  If (proc > 0) And (error = #False)
    MessageRequester("PBSScript-Compiler", "Rckgabe der Procedure:"+Chr(10)+GetValueText(value))
  EndIf
EndProcedure


Procedure CallProcedure(name.s)
  count = PBSGetProcedureCountParams(0, name)
  optio = PBSGetProcedureCountOptio(0, name)
  CountProcParam = count
  If (count = 0)
    ProcedureReturn #True
  EndIf
  
  ReDim ProcParam.PBSValue(count-1)
  For i = 0 To count-1
    ClearStructure(ProcParam(i), PBSValue)
    ProcParam(i)\type = PBSGetProcedureParamType(0, name, i)
  Next
  
  hei = 75+count*30
  If OpenWindow(1, 0, 0, 320, hei, "PBSScript-Compiler - Procedureaufruf", #PB_Window_SystemMenu|1, WindowID(0))
    EnableWindow_(WindowID(0), 0)
    
    AddKeyboardShortcut(1, #PB_Shortcut_Return, 10)
    AddKeyboardShortcut(1, #PB_Shortcut_Escape, 11)
    
    TextGadget(#PB_Any, 5, 5, 310, 15, "Procedure "+name+"()", #PB_Text_Center)
    Frame3DGadget(#PB_Any, 5, 20, 310, hei-55, "Parameter:")
    For i = 0 To count-1
      If (i < count-optio)
        check = CheckBoxGadget(#PB_Any, 15, 40+i*30, 18, 15, "")
        SetGadgetState(check, 1)
        DisableGadget(check, 1)
        TextGadget(#PB_Any, 33, 40+i*30, 57, 15, "("+GetTypeText(PBSGetProcedureParamType(0,name,i))+")")
      Else
        CheckBoxGadget(22+i*4, 15, 40+i*30, 75, 15, "("+GetTypeText(PBSGetProcedureParamType(0,name,i))+")")
        SetGadgetState(22+i*4, 1)
      EndIf
      StringGadget(20+i*4, 90, 37+i*30, 175, 20, GetValueText(ProcParam(i)), #PB_String_ReadOnly)
      ButtonGadget(21+i*4, 270, 37+i*30, 35, 20, "Set")
    Next
    ButtonGadget(10,  70, hei-25, 85, 20, "Aufruf")
    ButtonGadget(11, 165, hei-25, 85, 20, "Abbruch")
    
    
    Repeat
      event = WaitWindowEvent()
      
      If (event = #PB_Event_Gadget)
        egid = EventGadget()
        If (egid = 10)
          CloseWindow(1)
          EnableWindow_(WindowID(0), 1)
          ProcedureReturn #True
        ElseIf (egid = 11)
          quit = 1
        ElseIf (egid >= 21) And ((egid % 4) = 1)
          idx = (egid-21)/4
          If InputValueText(ProcParam(idx))
            SetGadgetText(egid-1, GetValueText(ProcParam(idx)))
          EndIf
        ElseIf (egid >= 22) And ((egid % 4) = 2)
          idx = (egid-22)/4
          get = GetGadgetState(egid)
          HideGadget(egid-1, 1-get)
          HideGadget(egid-2, 1-get)
          If (get = 0)
            For i = idx+1 To count-1
              HideGadget(20+i*4, 1)
              HideGadget(21+i*4, 1)
              SetGadgetState(22+i*4, 0)
            Next
            CountProcParam = idx
          Else
            For i = count-optio To idx-1
              HideGadget(20+i*4, 0)
              HideGadget(21+i*4, 0)
              SetGadgetState(22+i*4, 1)
            Next
            CountProcParam = idx+1
          EndIf
        EndIf
      EndIf
      
      If (event = #PB_Event_Menu)
        emid = EventMenu()
        If (emid = 10)
          CloseWindow(1)
          EnableWindow_(WindowID(0), 1)
          ProcedureReturn #True
        ElseIf (emid = 11)
          quit = 1
        EndIf
      EndIf
      
      If (event = #PB_Event_CloseWindow)
        quit = 1
      EndIf
      
    Until quit
    
    CloseWindow(1)
    EnableWindow_(WindowID(0), 1)
  EndIf
  ProcedureReturn #False
EndProcedure


Declare DisplayCollect(name.s, range.s)
  
Procedure RefreshVarList(gadget, collect, *colwin.collectwindow=0)
  Protected value.PBSValue
  If (*colwin <> #Null)
    If (*colwin\collect = #PBSCollect_Array)
    ElseIf (*colwin\collect = #PBSCollect_List)
      If (PBSCallListProcedure(0, *colwin\name, #PBSProc_ListSize) <> *colwin\size)
        DisplayCollect(*colwin\name, *colwin\range)
      EndIf
      PBSPauseScript(0)
      resume = #True
    EndIf
  EndIf
  count = CountGadgetItems(gadget)
  For i = 0 To count-1
    name.s = GetGadgetItemText(gadget, i, 1)
    Select collect
    Case #PBSCollect_Array
      text.s = ""
      dimens = PBSGetVariableDimens(0, name)
      For k = 0 To dimens-1
        If (k > 0)
          text + ","
        EndIf
        text + Str(PBSGetArraySize(0, name, k+1))
      Next
      SetGadgetItemText(gadget, i, text, 2)
    Case #PBSCollect_List
      size = PBSCallListProcedure(0, name, #PBSProc_ListSize)
      If (size = -1)
        SetGadgetItemText(gadget, i, "-", 2)
        SetGadgetItemText(gadget, i, "-", 3)
      Else
        SetGadgetItemText(gadget, i, Str(size), 2)
        current = PBSCallListProcedure(0, name, #PBSProc_ListIndex)
        If (current = -1)
          SetGadgetItemText(gadget, i, "-", 3)
        Else
          SetGadgetItemText(gadget, i, Str(current), 3)
        EndIf
      EndIf
    Default
      *change = -1
      varname.s = name
      pos = FindString(varname, ")", 0)
      If (pos <> 0)
        varname = StringField(varname, 1, "(") + "(" + Mid(varname,pos)
        If (*colwin <> #Null)
          If (*colwin\collect = #PBSCollect_List)
            If (PBSCallListProcedure(0, varname, #PBSProc_ListIndex) > -1)
              *change = PBSGetVariableInteger(0, "@"+varname)
            Else
              *change = 0
            EndIf
            PBSCallListProcedure(0, varname, #PBSProc_SelectElement, Val(StringField(name, 2, ":")))
            name = varname
          EndIf
        EndIf
      EndIf
      If (PBSGetVariableType(0, varname) <> #PBSType_Structure)
        PBSGetVariableValue(0, name, value)
        SetGadgetItemText(gadget, i, GetValueText(value), 2)
      EndIf
      If (*change = -1)
      ElseIf (*change = 0)
        PBSCallListProcedure(0, varname, #PBSProc_ResetList)
      Else
        PBSCallListProcedure(0, varname, #PBSProc_ChangeCurrentElement, *change)
      EndIf
    EndSelect
  Next
  If (resume = #True)
    PBSResumeScript(0)
  EndIf
EndProcedure


Procedure DisplayCollect(name.s, range.s)
  collect = PBSGetVariableCollect(0, name)
  
  If (collect = #PBSCollect_Array)
    dimens = PBSGetVariableDimens(0, name)
    Dim dimrange.dimrange(dimens-1)
    For i = 0 To dimens-1
      arrsize = PBSGetArraySize(0, name, i+1)
      str.s = Trim(StringField(range, i+1, ","))
      If (str = "")
        dimrange(i)\min = 0
        dimrange(i)\max = arrsize
      ElseIf FindString(str, "-", 0)
        dimrange(i)\min = Val(Trim(StringField(str, 1, "-")))
        dimrange(i)\max = Val(Trim(StringField(str, 2, "-")))+1
      Else
        dimrange(i)\min = Val(str)
        dimrange(i)\max = Val(str)+1
      EndIf
      dimrange(i)\pos = dimrange(i)\min
      If (dimrange(i)\max > arrsize) Or (dimrange(i)\min < 0) Or (dimrange(i)\min > dimrange(i)\max)
        MessageRequester("PBScript-Compiler", "Bereich auerhalb der Grenzen")
        ProcedureReturn 
      EndIf
    Next
  EndIf
  
  found = #False
  ForEach collectwindow()
    If (collectwindow()\name = name)
      found = #True
      Break
    EndIf
  Next
  If (found = #False)
    AddElement(collectwindow())
    collectwindow()\winid  = OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 280, 300, "Anzeige von "+name, #PB_Window_Tool|#PB_Window_SystemMenu, WindowID(0))
    collectwindow()\listid = ListIconGadget(#PB_Any, 5, 5, 270, 290, "Typ", 60, #PB_ListIcon_FullRowSelect)
    AddGadgetColumn(collectwindow()\listid, 1, "Name", 100)
    AddGadgetColumn(collectwindow()\listid, 2, "Wert", 85)
  Else
    ClearGadgetItems(collectwindow()\listid)
  EndIf
  collectwindow()\name   = name
  collectwindow()\range  = range
  collectwindow()\collect = collect
  type = PBSGetVariableType(0, name)
  typetext.s = "("+GetTypeText(type)+")"
  
  If (collect = #PBSCollect_Array)
    i = dimens-1
    Repeat
      str = ""
      For k = 0 To dimens-1
        If (k > 0)
          str + ","
        EndIf
        str + Str(dimrange(k)\pos)
      Next
      newname.s = Left(name,Len(name)-1)+str+")"
      AddGadgetItem(collectwindow()\listid, -1, typetext+Chr(10)+newname)
      If (type = #PBSType_Structure)
        AddStrucItem(collectwindow()\listid, newname, PBSGetVariableStruc(0,name))
      EndIf
      dimrange(i)\pos + 1
      While (dimrange(i)\pos >= dimrange(i)\max)
        dimrange(i)\pos = dimrange(i)\min
        i - 1
        If (i < 0)
          Break 2
        EndIf
        dimrange(i)\pos + 1
      Wend
      i = dimens-1
    ForEver
  ElseIf (collect = #PBSCollect_List)
    If (found = #False)
      collectwindow()\size = -1
    Else
      collectwindow()\size = PBSCallListProcedure(0, name, #PBSProc_ListSize)
      For i = 0 To collectwindow()\size-1
        newname.s = Left(name,Len(name)-1)+":"+Str(i)+":)"
        AddGadgetItem(collectwindow()\listid, -1, typetext+Chr(10)+newname)
        If (type = #PBSType_Structure)
          AddStrucItem(collectwindow()\listid, newname, PBSGetVariableStruc(0,name))
        EndIf
      Next
    EndIf
  EndIf
  If (found = #True)
    SetGadgetState(collectwindow()\listid, position)
  EndIf
  
  RefreshVarList(collectwindow()\listid, 0, collectwindow())
EndProcedure


If OpenWindow(0, 0, 0, 460, 300, "PBScript-Compiler", #PB_Window_MinimizeGadget|1)
  AddKeyboardShortcut(0, #PB_Shortcut_Escape, 11)
  
  If CreateStatusBar(0, WindowID(0))
    AddStatusBarField(460)
    StatusBarText(0, 0, "Script geladen", #PB_StatusBar_Center)
  EndIf
  
  TextGadget(#PB_Any, 5, 5, 160, 15, "Alle Proceduren im Script:")
  ListViewGadget(0, 5, 20, 160, 275-StatusBarHeight(0))
  AddGadgetItem(0, -1, "--- StartCode ---")
  count = PBSGetCountProcedures(0)
  For i = 0 To count-1
    AddGadgetItem(0, -1, PBSGetProcedureName(0, i)+"()")
  Next
  
  PanelGadget(9, 175, 5, 280, 290-StatusBarHeight(0))
  AddGadgetItem(9, -1, "Variablen")
  panelheight = GetGadgetAttribute(9, #PB_Panel_TabHeight)
  TextGadget(#PB_Any, 5, 3, 270, 15, "Alle global Variablen im Script:")
  ListIconGadget(1, 5, 18, 270, 265-StatusBarHeight(0)-panelheight, "Typ", 60, #PB_ListIcon_FullRowSelect)
  AddGadgetColumn(1, 1, "Name", 100)
  AddGadgetColumn(1, 2, "Wert", 85)
  AddGadgetItem(9, -1, "Arrays")
  TextGadget(#PB_Any, 5, 3, 270, 15, "Alle global Arrays im Script:")
  ListIconGadget(2, 5, 18, 270, 265-StatusBarHeight(0)-panelheight, "Typ", 60, #PB_ListIcon_FullRowSelect)
  AddGadgetColumn(2, 1, "Name", 100)
  AddGadgetColumn(2, 2, "Dimension", 85)
  AddGadgetItem(9, -1, "Listen")
  TextGadget(#PB_Any, 5, 3, 270, 15, "Alle global Listen im Script:")
  ListIconGadget(3, 5, 18, 270, 265-StatusBarHeight(0)-panelheight, "Typ", 60, #PB_ListIcon_FullRowSelect)
  AddGadgetColumn(3, 1, "Name", 75)
  AddGadgetColumn(3, 2, "Gre", 55)
  AddGadgetColumn(3, 3, "Aktuell", 55)
  count = PBSGetCountVariables(0)
  For k = 0 To 2
    For i = 0 To count-1
      name.s = PBSGetVariableName(0, i)
      If (PBSGetVariableCollect(0, name) = k)
        type = PBSGetVariableType(0,name)
        If (k = 0)
          AddGadgetItem(k+1, -1, "("+GetTypeText(type)+")"+Chr(10)+name+Chr(10))
          If (type = #PBSType_Structure)
            AddStrucItem(k+1, name, PBSGetVariableStruc(0,name))
          EndIf
        Else
          AddGadgetItem(k+1, -1, "("+GetTypeText(type)+")"+Chr(10)+name)
        EndIf
      EndIf
    Next
  Next
  RefreshVarList(1, 0)
  
  If (isstartcode = #True)
    DisableGadget(0, 1)
    IsScriptRun = 1
    StatusBarText(0, 0, "Das Programm luft...", #PB_StatusBar_Center)
    ThreadID = CreateThread(@StartCode(), 0)
  EndIf
  
  
  Repeat
    event = WaitWindowEvent(5)
    
    If (ListSize(debugstring()) > 0)
      If (IsWindow(10) = #False)
        If OpenWindow(10, #PB_Ignore, #PB_Ignore, 200, 300, "PBScript-Compiler - Ausgabe", #PB_Window_Tool|#PB_Window_SystemMenu, WindowID(0))
          ListViewGadget(5, 5, 5, WindowWidth(10)-10, WindowHeight(10)-10)
        EndIf
      EndIf
      LockMutex(debugmutex)
        Repeat
          FirstElement(debugstring())
          AddGadgetItem(5, -1, debugstring())
          DeleteElement(debugstring())
        Until (IsScriptRun <> 0) Or (NextElement(debugstring()) = 0)
      UnlockMutex(debugmutex)
      SetGadgetState(5, CountGadgetItems(5)-1)
    EndIf
    
    If (IsScriptRun <> 0)
      If (ElapsedMilliseconds() >= Time)
        If (IsScriptRun = -1)
          IsScriptRun = 0
        EndIf
        collect = GetGadgetState(9)
        gadget = collect+1
        RefreshVarList(gadget, collect)
        ForEach collectwindow()
          RefreshVarList(collectwindow()\listid, 0, collectwindow())
        Next
        Time = ElapsedMilliseconds()+100
      EndIf
    EndIf
    
    If (event = #PB_Event_Gadget)
      egid = EventGadget()
      If (EventType() = #PB_EventType_LeftDoubleClick)
        If (egid = 0)
          proc = GetGadgetState(0)
          If (proc > 0)
            If (CallProcedure(StringField(GetGadgetItemText(0,proc),1,"(")) = #False)
              proc = -1
            EndIf
          EndIf
          If (proc > -1)
            DisableGadget(0, 1)
            IsScriptRun = 1
            StatusBarText(0, 0, "Das Programm luft...", #PB_StatusBar_Center)
            ThreadID = CreateThread(@StartCode(), proc)
          EndIf
        ElseIf (egid = 1)
          If (IsScriptRun = 0)
            get = GetGadgetState(1)
            If (get > -1)
              name.s = GetGadgetItemText(1, get, 1)
              If (PBSGetVariableType(0, name) <> #PBSType_Structure)
                PBSGetVariableValue(0, name, value)
                If InputValueText(value)
                  PBSSetVariableValue(0, name, value)
                  SetGadgetItemText(1, get, GetValueText(value), 2)
                EndIf
              EndIf
            EndIf
          EndIf
        ElseIf (egid = 2) Or (egid = 3)
          collect = GetGadgetState(9)
          get = GetGadgetState(egid)
          If (get > -1)
            name.s = GetGadgetItemText(egid, get, 1)
            DisplayCollect(name, "")
          EndIf
        Else
          ForEach collectwindow()
            If (collectwindow()\listid = egid)
              If (IsScriptRun = 0)
                get = GetGadgetState(egid)
                If (get > -1)
                  *change = -1
                  name.s = GetGadgetItemText(egid, get, 1)
                  varname.s = name
                  pos = FindString(varname, ")", 0)
                  If (pos <> 0)
                    varname = StringField(varname, 1, "(") + "(" + Mid(varname,pos)
                    If (collectwindow()\collect = #PBSCollect_List)
                      If (PBSCallListProcedure(0, varname, #PBSProc_ListIndex) > -1)
                        *change = PBSGetVariableInteger(0, "@"+varname)
                      Else
                        *change = 0
                      EndIf
                      PBSCallListProcedure(0, varname, #PBSProc_SelectElement, Val(StringField(name, 2, ":")))
                      name = varname
                    EndIf
                  EndIf
                  If (PBSGetVariableType(0, varname) <> #PBSType_Structure)
                    PBSGetVariableValue(0, name, value)
                    If InputValueText(value)
                      PBSSetVariableValue(0, name, value)
                      SetGadgetItemText(egid, get, GetValueText(value), 2)
                    EndIf
                  EndIf
                  If (*change = -1)
                  ElseIf (*change = 0)
                    PBSCallListProcedure(0, varname, #PBSProc_ResetList)
                  Else
                    PBSCallListProcedure(0, varname, #PBSProc_ChangeCurrentElement, *change)
                  EndIf
                EndIf
              EndIf
            EndIf
          Next
        EndIf
      ElseIf (EventType() = #PB_EventType_RightClick)
        If (egid = 2) Or (egid = 3)
          If (IsScriptRun = 0)
            get = GetGadgetState(gadget)
            If (get > -1)
              If CreatePopupMenu(0)
                MenuItem(0, "Alle Eintrge")
                MenuItem(1, "Bereich anzeigen")
              EndIf
              DisplayPopupMenu(0, WindowID(0))
            EndIf
          EndIf
        EndIf
      EndIf
      If (egid = 9)
        If (IsScriptRun = 0)
          IsScriptRun = -1
        EndIf
      EndIf
    EndIf
    
    If (event = #PB_Event_Menu)
      emid = EventMenu()
      If (emid = 0) Or (emid = 1)
        collect = GetGadgetState(9)
        get = GetGadgetState(egid)
        If (get > -1)
          range.s = ""
          If (emid = 1)
            range = InputRequester("PBScript-Compiler", "Bereich zum Anzeigen eingeben:", "")
          EndIf
          name.s = GetGadgetItemText(egid, get, 1)
          DisplayCollect(name, range)
        EndIf
      ElseIf (emid = 11)
        quit = 1
      EndIf
    EndIf
    
    If (event = #PB_Event_CloseWindow)
      ewid = EventWindow()
      If (ewid = 0)
        quit = 1
      ElseIf (ewid = 10)
        CloseWindow(10)
      Else
        ForEach collectwindow()
          If (collectwindow()\winid = ewid)
            DeleteElement(collectwindow())
            Break
          EndIf
        Next
        CloseWindow(ewid)
      EndIf
    EndIf
    
  Until quit
EndIf

; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; EnableThread
; Executable = PBScript-Compiler.exe
; SubSystem = UserLibThreadSafe